
/*
 *  header - $Id: memguard_internal.h,v 1.2 1997/06/07 00:34:17 qian Exp $
 *
 *  internel API of the memory-based guard tool
 */


/*********************************************************************
types & constants
*********************************************************************/


/*********************************************************************
variables
*********************************************************************/

/*
 * Variables  : int mgEnabled
 * Description: if the memory-based guard tool is enabled
 */
/* if the memory-based guard tool is enabled */
extern int mgEnabled;


/*********************************************************************
functions
*********************************************************************/

/*
 * Functions  : int mgInit(int benabled, u_int nregion, u_int ninvariant)
 *              int mgAddRegion(caddr_t vaddr, u_int size)
 *              int mgDeleteRegion(caddr_t vaddr)
 * Description: initialization
 */
extern int mgInit(int benabled, u_int nregion, u_int ninvariant);
#    define MG_INIT_OK		0	/* success */
#    define MG_INIT_NREGION	-1	/* invalid number of regions */
#    define MG_INIT_NINVARIANT	-2	/* invalid number of invariants */

/* add a guarded region */
extern int mgAddRegion(caddr_t vaddr, u_int size);
#    define MG_ADDREG_OK	0	/* success */
#    define MG_ADDREG_VADDR	-1	/* invalid virtual address */
#    define MG_ADDREG_SIZE	-2	/* invalid region size */
#    define MG_ADDREG_FULL	-3	/* too many regions */
#    define MG_ADDREG_NOSPACE	-4	/* too many pages */

/* delete a guarded region, do NOT support */
extern int mgDeleteRegion(caddr_t vaddr);
#    define MG_DELREG_OK	0	/* success */
#    define MG_DELREG_VADDR	-1	/* invalid virtual address */

/*
 * Functions  : int mgFault(caddr_t vaddr, u_short length)
 * Description: memguard page protection fault function
 */
/* memguard page protection fault function */
extern int mgFault(caddr_t vaddr, u_short length);
#    define MG_FAULT_YES	0	/* this is memguard fault */
#    define MG_FAULT_NO		-1	/* this is not memguard fault */

